/* Initial beliefs and rules */

my_group("easssGr").
my_ssch("easssSch").

ngreetings(0).

/* Initial goals */
!setup.

// Initialisation Plans
 
+!setup : my_group(Gr) & my_ssch(Sch)
	<- 	.my_name(Me);
		.concat("group_console_",Me,GCN);
		makeArtifact(GCN,"easss.step.GroupConsole",[Me],GCId);
		.println("Did a group-console with Id ", GCId);
		focus(GCId);
		.concat("scheme_console_",Me,SCN);
		makeArtifact(SCN,"easss.step.SchemeConsole",[Me],SCId);
		.println("Did a scheme-console with Id ", SCId);
		focus(SCId);
		joinRemoteWorkspace("server","localhost",WspID2);
		println("ready");	
	   	!enter_organization(Gr,Sch).

-!setup 
	<- 	.wait(1000);
		!setup.
	
// Agent's organizational skills

+!enter_organization(Gr,Sch)
	<- 	// Focusing on groupboard managing my group
		lookupArtifact(Gr,GId);
		+my_group_id(GId);
		focus(GId);
		// Focusing on schemeboard managing my social scheme
		lookupArtifact(Sch,SId);
		+my_scheme_id(SId);	
		focus(SId).

-!enter_organization(Gr,Sch)
	<- 	.println("Unable to enter the organization. Staying out").

// Reactive plans for events generated by the group management console (decisions of my user)
+cmd("adoptRole",Group,Role)
	<- 	.println("Going to adopt ",Role," in ",Group);
		lookupArtifact(Group,GroupId);
		adoptRole(Role)[artifact_id(GroupId)];
		.println("Role adopted").

-cmd("adoptRole",Group,Role)
	<- 	.println("Going to adopt ",Role," in ",Group);
		lookupArtifact(Group,GroupId);
		adoptRole(Role)[artifact_id(GroupId)];
		.println("Role adopted").
				
+cmd("leaveRole",Group,Role)
	<- 	.println("Going to leave ",Role," in ",Group);
		lookupArtifact(Group,GroupId);
		leaveRole(Role)[artifact_id(GroupId)];
		.println("Role left").
		
+cmd("addScheme",Group,Scheme) 
	<- 	.println("Going to add scheme ",Scheme," in ",Group);
		lookupArtifact(Group,GroupId);
      	addScheme(Scheme)[artifact_id(GroupId)];
      	.println("Scheme added").

+cmd("removeScheme",Group,Scheme)
	<- 	.println("Going to remove scheme ",Scheme," from ",Group);
		lookupArtifact(Group,GroupId);
		removeScheme(Scheme)[artifact_id(GroupId)];
		.println("Scheme removed").

// Reactive plans for events generated by the scheme management console (decisions of my user)
+cmd("commitMission",Scheme,Mission)
	<- 	.println("Going to commit ",Mission," in ",Scheme);
		lookupArtifact(Scheme,SchemeId);
		commitMission(Mission)[artifact_id(SchemeId)];
		.println("Committed to mission").

+cmd("leaveMission",Scheme,Mission)
	<- 	.println("Going to leave ",Mission," in ",Scheme);
		lookupArtifact(Scheme,SchemeId);
		leaveMission(Mission)[artifact_id(SchemeId)];
		.println("Mission left.").

+cmd("goalAchieved",Scheme,Goal)
	<- 	.println("Goal ", Goal, " has been achieved in ",Scheme);
		lookupArtifact(Scheme,SchemeId);
      	goalAchieved(Goal)[artifact_id(SchemeId)];
      	.println("Goal achieved").

// Agent's skills

+!easss
	<-	.println("Achieving easss").
	
+!greet_for_ever
	<-	.my_name(Me);
	   	!greet_task("Do you want a gin tonic?").

-!greet_for_ever
	<- 	.wait(1000);
   		!greet_for_ever.

+!greet_task(Message) : ngreetings(N) & N<50
	<- 	.wait(math.random(500)+10);
		-+ngreetings(N+1);
	   	printMsg(Message);
	   	!greet_task(Message).	

+!compute
	<-  /* discovering and using the calcultor */
	    lookupArtifact("calculator",CalcId);
		computePi(100,Digits) [artifact_id(CalcId)];
		
		/* discovering and using the message console */
		lookupArtifact("msg-console",ConsoleId);
		printMsg(Digits)[artifact_id(ConsoleId)].
		
-!compute
	<- 	.wait(1000);
		!compute.
				
+!observe
 	<- lookupArtifact("msg-console",Id);
	   focus(Id).
	   
+numMsg(N) 
	<- println("new message: total number is ",N).

-!observe
	<- .wait(1000);
	   !observe.	
	   