/* EASSS 2012 Practical Laboratory for EOOP course    */
/* Benevolent agent with respect to the organisation. */

/* Initial beliefs and rules */
my_group("easssGr").
my_ssch("easssSch").
my_role("computer").


ngreetings(0).

/* Initial goals */
!setup.

// Initialisation Plans
 
+!setup : my_group(Gr) & my_ssch(Sch) & my_role(Role)
	<- 	.my_name(Me);
		joinRemoteWorkspace("server","localhost",WspID2);
		println("ready");	
	   	!enter_organization(Gr,Sch,Role).

-!setup 
	<- 	.wait(1000);
		!setup.
	
// Agent's organizational skills

+!enter_organization(Gr,Sch,Role)
	<- 	// Focusing on groupboard managing my group
		lookupArtifact(Gr,GId);
		+my_group_id(GId);
		focus(GId);
		adoptRole(Role)[artifact_id(GId)];
		// Focusing on schemeboard managing my social scheme
		lookupArtifact(Sch,SId);
		+my_scheme_id(SId);	
		focus(SId).

-!enter_organization(Gr,Sch)
	<- 	.println("Unable to enter the organization. Staying out").

// Reactive plans for events generated by the group management console (decisions of my user)
+cmd("adoptRole",Group,Role)
	<- 	.println("Going to adopt ",Role," in ",Group);
		lookupArtifact(Group,GroupId);
		adoptRole(Role)[artifact_id(GroupId)];
		.println("Role adopted").

+cmd("leaveRole",Group,Role)
	<- 	.println("Going to leave ",Role," in ",Group);
		lookupArtifact(Group,GroupId);
		leaveRole(Role)[artifact_id(GroupId)];
		.println("Role left").
		
+cmd("addScheme",Group,Scheme) 
	<- 	.println("Going to add scheme ",Scheme," in ",Group);
		lookupArtifact(Group,GroupId);
      	addScheme(Scheme)[artifact_id(GroupId)];
      	.println("Scheme added").

+cmd("removeScheme",Group,Scheme)
	<- 	.println("Going to remove scheme ",Scheme," from ",Group);
		lookupArtifact(Group,GroupId);
		removeScheme(Scheme)[artifact_id(GroupId)];
		.println("Scheme removed").

// Reactive plans for events generated by the scheme management console (decisions of my user)
+cmd("commitMission",Scheme,Mission)
	<- 	.println("Going to commit ",Mission," in ",Scheme);
		lookupArtifact(Scheme,SchemeId);
		commitMission(Mission)[artifact_id(SchemeId)];
		.println("Committed to mission").

+cmd("leaveMission",Scheme,Mission)
	<- 	.println("Going to leave ",Mission," in ",Scheme);
		lookupArtifact(Scheme,SchemeId);
		leaveMission(Mission)[artifact_id(SchemeId)];
		.println("Mission left.").

+cmd("goalAchieved",Scheme,Goal)
	<- 	.println("Goal ", Goal, " has been achieved in ",Scheme);
		lookupArtifact(Scheme,SchemeId);
      	goalAchieved(Goal)[artifact_id(SchemeId)];
      	.println("Goal achieved").

// plans to handle obligations
+obligation(Ag,Norm,committed(Ag,Mission,Scheme),Deadline)
    : .my_name(Ag)
   <- .println("I am obliged to commit to ",Mission," on ",Scheme);
      commitMission(Mission)[artifact_name(Scheme)].
      
+obligation(Ag,Norm,achieved(Scheme,Goal,Ag),Deadline)
    : .my_name(Ag)
   <- .println("I am obliged to achieve goal ",Goal);
      !Goal[scheme(Scheme)];
      goalAchieved(Goal)[artifact_name(Scheme)].
      
+obligation(Ag,Norm,What,Deadline)  
   : .my_name(Ag)
   <- .print("I am obliged to ",What,", but I don't know what to do!").
	      
// Agent's skills

+!easss
	<-	.println("Achieving easss").
	
+!greet_for_ever
	<-	.my_name(Me);
	   	!greet_task("Do you want a gin tonic?").

-!greet_for_ever
	<- 	.wait(1000);
   		!greet_for_ever.

+!greet_task(Message) : ngreetings(N) & N<50
	<- 	.wait(math.random(500)+10);
		-+ngreetings(N+1);
	   	printMsg(Message);
	   	!greet_task(Message).	

+!compute
	<-  /* discovering and using the calcultor */
	    lookupArtifact("calculator",CalcId);
		computePi(100,Digits) [artifact_id(CalcId)];
		
		/* discovering and using the message console */
		lookupArtifact("msg-console",ConsoleId);
		printMsg(Digits)[artifact_id(ConsoleId)].
		
-!compute
	<- 	.wait(1000);
		!compute.
				
+!observe
 	<- lookupArtifact("msg-console",Id);
	   focus(Id).
	   
+numMsg(N) 
	<- println("new message: total number is ",N).

-!observe
	<- .wait(1000);
	   !observe.	
	   